// UԂŎшvZ

// EffBw.cpp : R\[ AvP[ṼGg |Cg`܂B
//

//CN[h
#include "stdafx.h"
#include<float.h>

#include "input_const.h"

//O
using namespace std;

//\̂̐錾
typedef struct{
	double	arrival_rate;
	int		buffer_size;
	double	Pr_Q_than_B;
	int		t;
} str_data;


// vg^Cv錾
static str_data input(void);
static int poisson( double arrival_rate );
static int get_poison_LBA_EffBw(str_data data1);


//O[oϐ̐錾

// }N
#define RAND1() ( (double)rand() / (RAND_MAX - 0x1) ) //0`PԂ̃}N



// ===================================================================
// @e֐




// f[^̓
static str_data input(void){
	
	str_data data1;		//\̂̎̂̐錾

	data1.buffer_size = 10;			//obt@TCY
	data1.arrival_rate = 10;		// [g
	data1.Pr_Q_than_B  = 1e-10;		// Pr(Q>B) obt@m 
	data1.t = 1;	//X[0,t] ɂ "t" [step]
	return data1;

}


// |\zɏ]𔭐֐

static int poisson(double arrival_rate) { 
    int k; 
    arrival_rate = exp(arrival_rate) * RAND1(); 
    for (k = 0; arrival_rate > 1.0; k++)
            arrival_rate *= RAND1(); 

    return k; 
}



static int get_poison_LBA_EffBw(str_data data1){
	
	int frequency_dist[ ARRAY_SIZE_OF_FREQUENCY_DIST ]; //xz֐
	
	int x; // X[0,t] |\zɏ]n
	int x_max; //n̍ől
	double jBokansuu;
	double s_LBA;
	double EffBw;	//ш̃V~[Vl
	double Theorem_EffBw; //ш̗_l
	double jGosaritu;	//덷

	int i;
	int j;

	//z̏
	for( i = 0; i < ARRAY_SIZE_OF_FREQUENCY_DIST; i++){
		frequency_dist[ i ] = 0;
	}

	//ԃp[^̍œKlvZi[Wobt@j
	s_LBA = -log( data1.Pr_Q_than_B ) / data1.buffer_size;

	
	//ш̗_l̏o
	Theorem_EffBw = data1.arrival_rate * ( exp(s_LBA) - 1.0) / s_LBA;
	cout << "	" <<  Theorem_EffBw;


	// |\zɏ]nx̓xzfrequency_dist[x]쐬
	x_max = 0;
	for( i = 0; i < SIM_FINISH_TIME; i++){

		// X[0,t]̎f[^𓾂
		x = 0;
		for ( j=0; j < data1.t; j++){
			x += poisson( data1.arrival_rate );	//|\nxɑ
		}

		if(x > x_max) x_max = x;	//x̍ől𓾂
		if( x < ARRAY_SIZE_OF_FREQUENCY_DIST ){
			frequency_dist[ x ]++;
		}else{
			cout << "err z̃TCY܂" << endl;
			exit(1);
		}
	}

	//O[g֐ lnE[e^sx] ̌vZ
	//[~No.16(4)Q
	jBokansuu = 0.0;

	cout << endl << "#--------------" << endl;
	cout << "#s_LBA=" << s_LBA << endl;
	cout << "x	g	n(X=x)" << endl;
	for( i = 0; i <= x_max; i++){
		
		jBokansuu += exp( -s_LBA * ( x_max - i) ) * frequency_dist[ i ];

		cout <<i << "	" << exp( -s_LBA * ( x_max - i) )*frequency_dist[i] << "	" << frequency_dist[i] << endl;
	}
	cout << "--------------" << endl;

	jBokansuu = log ( jBokansuu / SIM_FINISH_TIME );
	jBokansuu += s_LBA * x_max;

	//ш̌vZ
	EffBw = jBokansuu / s_LBA / data1.t;


	//ш̌vZlo
	cout << "	" << EffBw;

	//덷̌vZAo
	jGosaritu = fabs(EffBw - Theorem_EffBw) / Theorem_EffBw;
	cout << "	" << jGosaritu;

	//̑AmFp̏o
	cout << "	" << x_max;
	cout << "	" << s_LBA;

	cout << endl;

	return 0;
}




int main(int argc, _TCHAR* argv[])
{
	double i;
	str_data data1 = input();


	//wb_̏o
	cout << "#LBA EffBw" << endl;
	cout << "#B=" << data1.buffer_size << "	P(Q>B)=" << data1.Pr_Q_than_B << endl;
	cout << "#=" << data1.arrival_rate 	                              << endl;
	cout << "#sim_finish_timeiTvj=" << SIM_FINISH_TIME << endl;
	cout << "t	theorem	sim	jGosaritu" << endl;



	//for ( i = 0; i<3; i++){
	

	//	data1.t = i;
	//	cout << i;


	get_poison_LBA_EffBw( data1 );
	
	//}

	return 0;
}

